# -*- coding: utf-8 -*-
"""
Created on Sun Dec 17 11:39:36 2017

@author: bubu
"""

"X est une variable aléatoire discrète finie"
"La loi de X est modélisée par une loi binomiale de paramètres n et p"
"---------------------------------------------------"
from scipy.stats import binom
from matplotlib import pyplot as plt


"------------- DISTRIBUTION ET RÉPARTITION DE X -----------------------"
# n, p = 10, .5
# distrib = [binom.pmf(x, n, p) for x in range(n + 1)]
# reparti = [binom.cdf(x, n, p) for x in range(n + 1)]

" Plus pratique :"
n, p = 10, .5

"x est la liste des valeurs (de 0 à n) de la variable aléatoire X"
x = range(n + 1)

"distrib est la liste des probabilités des valeurs prises par la variable X"
"    appelée aussi distribution de probabilité de la variable X"
distrib = binom.pmf(x, n, p)

"reparti est la liste des probabilités cumulées croissantes"
"    appelée aussi répartition de probabilité de la variable X"
reparti = binom.cdf(x, n, p)

"----------------------- GRAPHIQUES -----------------------------------"
" Le graphique de la distribution de X"
plt.figure()
plt.bar(x, distrib, color = 'blue')
plt.title("DISTRIBUTION DE PROBABILITÉ")
plt.xlabel("VALEURS DE LA V.A. X")
plt.ylabel("PROBABILITÉ")
plt.grid()
plt.show()


"Le graphique de la répartition de X"
plt.figure()
plt.bar(x, reparti, color = 'green')
plt.title("RÉPARTITION DE PROBABILITÉ")
plt.xlabel("VALEURS DE LA V.A. X")
plt.ylabel("PROBABILITÉ CUMULÉE")
plt.grid()
plt.show()


"La définition de l'IF de X au seuil de probabilité de (1 - alpha),"
"    donnée par le document ressource de première S est la suivante:"
"IF de X = [a ; b] avec
    "a est la plus petite valeur de X telle que p(X <= a) > (1 - seuil) / 2"
    "b est la plus petite valeur de X telle que p(X <= b) >= (1 + seuil) / 2"


"------------------------------ ALGO 1 ------------------------------------"
"Détermination de l'intervalle de fluctuation selon la définition"
"    du document ressource de 1ere S"
"C'est un IF bilatéral, de seuil (1 - alpha), 'symétrique' en probabilité"
"ALGO 1 : mise en oeuvre directe est explicite de la définition"
from scipy.stats import binom
n, p, seuil = 5, .6, 0.80

"x est la liste des valeurs (de 0 à n) de la variable aléatoire X"
x = range(n + 1)

"reparti est la liste des probabilités cumulées croissantes"
"    appelée aussi répartition de probabilité de la variable X"
reparti = binom.cdf(x, n, p)

"Les index des éléments de reparti qui sont > (1 - seuil)/2"
"Ces index sont des valeurs de la v.a. X"
idap = [i for i in x if reparti[i] > (1 - seuil) / 2]

"a est la plus petite valeur de X telle que p(X<= a) > (1 - seuil)/2"
a = min(idap)

"Les index des éléments de reparti qui sont >= (1 + seuil) / 2"
"Ces index sont des valeurs de la v.a. X"
idbp = [i for i in x if reparti[i] >= (1 + seuil) / 2]

"b est la plus petite valeur de X telle que p(X<= b) >= (1 + seuil) / 2"
b = min(idbp)

"Je calcule et j'affiche p(a <= X <= b)"
pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
print("l'IF au seuil de", seuil, "de la va X est :",
      "[", a, ";", b, "],\n sa probabilité est", pIF)

"----------------------"
"Construction du graphique de la répartition de X avec l'IF en couleur :"
"Il y a a barres de couleur rouge puis (b - a + 1) barres de couleur verte" 
"    puis à nouveau (n - b) barres de couleur rouge."
"Avec n = 5 ; p = 0,6 ; seuil = 0,80, on trouve a = 2 et b = 4."
listCoul = ['red'] * a + ['green'] * (b - a + 1) + ['red'] * (n - b)

"Je superpose tous les éléments du graphique, barres de couleur,"
"    droites rouges, titres divers, grille."
from matplotlib import pyplot as plt ; plt.figure()
plt.bar(x, reparti, color = listCoul)
plt.plot((0, n), ((1 - seuil) / 2, (1 - seuil) / 2), color = 'red')
plt.plot((0, n), ((1 + seuil) / 2, (1 + seuil) / 2), color = 'red')
plt.title("RÉPARTITION DE PROBABILITÉ")
plt.xlabel("VALEURS DE LA V.A. X")
plt.ylabel("PROBABILITÉS CUMULÉES CROISSANTES")
plt.grid()
plt.show()


"---------------------------------------------------"
"Une fonction correspondant à ALGO 1"
" Nécessite pyplot de matplotlib et binom de scipy.stats"
def IFBino1(n = 14, p = .6, seuil = .95):
    from scipy.stats import binom
    from matplotlib import pyplot as plt
    x = range(n + 1)
    reparti = binom.cdf(x, n, p)
    a = min([i for i in x if reparti[i] > ((1 - seuil) / 2)])
    b = min([i for i in x if reparti[i] >= (1 + seuil) / 2])
    pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
    print("l'IF au seuil de", seuil, "de la va X est :",
          "[", a, ";", b, "],\n sa probabilité est", pIF)
    distrib = binom.pmf(x, n, p)
    listCoul = ['red'] * a + ['green'] * (b - a + 1) + ['red'] * (n - b)
    plt.figure()
    plt.bar(x, reparti, color = listCoul) ; plt.xticks(x)
    plt.plot((0, n), ((1 - seuil) / 2, (1 - seuil) / 2), color = 'red')
    plt.plot((0, n), ((1 + seuil) / 2, (1 + seuil) / 2), color = 'red')
    plt.title("RÉPARTITION DE PROBABILITÉ")
    plt.xlabel("VALEURS DE LA V.A. X")
    plt.ylabel("PROBABILITÉS CUMULÉES CROISSANTES")
    plt.grid()
    plt.show()


"------------------------------------------------------------------------"
"----------------------PROLONGEMENTS ------------------------------------"
"------------------------------ ALGO 2 ------------------------------------"
"Détermination de l'intervalle de fluctuation selon la définition"
"    du document ressource de 1ere S"
"C'est un IF bilatéral, de seuil (1 - alpha), 'symétrique' en probabilité"
from scipy.stats import binom
n, p, seuil = 5, .6, 0.80

"x est la liste des valeurs (de 0 à n) de la variable aléatoire X"
x = range(n + 1)

"reparti est la liste des probabilités cumulées croissantes"
"    appelée aussi répartition de probabilité de la variable X"
reparti = binom.cdf(x, n, p)

"Je repère par 'True' toutes les valeurs de reparti qui sont <= (1 - seuil) / 2"
boolam = reparti <= (1 - seuil) / 2

"La somme des 'True' transformées en 1 donne la valeur de a"
a = sum(boolam)

"Je repère par 'True' toutes les valeurs de reparti qui sont < (1 + seuil) / 2"
boolbm = reparti < (1 + seuil) / 2

"La somme des 'True' transformées en 1 donne la valeur de b"
b = sum(boolbm)

"Je calcule p(a <= X <= b)"
pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
" ou aussi"
" distrib = binom.pmf(x, n, p)"
" pIF = sum(distrib[range(a, b + 1)])"
print("l'IF au seuil de", seuil, "de la va X est :",
      "[", a, ";", b, "],\n sa probabilité est", pIF)


"------------------------------ ALGO 3 ------------------------------------"
"Détermination de l'intervalle de fluctuation selon la définition"
"    du document ressource de 1ere S"
"C'est un IF bilatéral, de seuil (1 - alpha), 'symétrique' en probabilité"
from scipy.stats import binom
n, p, seuil = 10, .5, 0.95

"x est la liste des valeurs x (de 0 à n) de la variable aléatoire X"
x = range(n + 1)

"reparti est la liste des probabilités cumulées croissantes"
"    appelée aussi répartition de probabilité de la variable X"
reparti = binom.cdf(x, n, p)

"i est le compteur des index de reparti, initialisé à 0"
"Je parcours la liste reparti et tant que p(X <= i) <= (1 - seuil)/2, j'ajoute 1 à i"
"a est la dernière valeur de i obtenue en fin de boucle"
i = 0
while reparti[i] <= (1 - seuil) / 2:
    i += 1
a = i

"j est le compteur des index de reparti, initialisé à 0"
"Je parcours la liste reparti et tant que p(X <= j) < (1 + seuil) / 2, j'ajoute 1 à j"
"b est la dernière valeur de j obtenue en fin de boucle"
j = 0
while reparti[j] < (1 + seuil) / 2:
    j += 1
b = j

"Je calcule et j'affiche p(a <= X <= b)"
pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
print("l'IF au seuil de", seuil, "de la va X est :",
      "[", a, ";", b, "],\n sa probabilité est", pIF)


"------------------------------ ALGO 4 ------------------------------------"
"Détermination de l'intervalle de fluctuation selon la définition"
"    du document ressource de 1ere S"
"C'est un IF bilatéral, de seuil (1 - alpha), 'symétrique' en probabilité"
"ALGO 4 : Quelle différence avec ALGO 3. Est-ce une amélioration ?"
from scipy.stats import binom
n, p, seuil = 10, .5, 0.95
x = range(n + 1)
reparti = binom.cdf(x, n, p)
i = 0
while reparti[i] <= (1 - seuil) / 2:
    i += 1
a = i
while reparti[i] < (1 + seuil) / 2:
    i += 1
b = i
pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
print("l'IF au seuil de", seuil, "de la va X est :",
      "[", a, ";", b, "],\n sa probabilité est", pIF)


"------------------------------ ALGO 5 ------------------------------------"
"Détermination de l'intervalle de fluctuation selon la définition"
"    du document ressource de 1ere S"
"C'est un IF bilatéral, de seuil (1 - alpha), 'symétrique' en probabilité"
from scipy.stats import binom
n, p, seuil = 10, .5, 0.95

"x est la liste des valeurs (de 0 à n) de la variable aléatoire X"
x = range(n + 1)

"reparti est la liste des probabilités cumulées croissantes"
"    appelée aussi répartition de probabilité de la variable X"
reparti = binom.cdf(x, n, p)

"Si p(X = 0) > (1 - seuil) / 2 alors a = 0"
if reparti[0] > (1 - seuil) / 2:
    a = 0

"Je parcours la liste reparti et je compare p(X <= i - 1) avec p(X <= i)"
"Je note les indices correspondant au 'passage des seuils'"
"Si p(X <= i - 1) <=  (1 - seuil) / 2 ET p(X <= i) >  (1 - seuil) / 2 alors a = i"
"Si p(X <= i - 1) <  (1 + seuil) / 2 ET p(X <= i) >=  (1 + seuil) / 2 alors b = i"
for i in range(2, n + 1):
    if (reparti[i - 1] <= (1 - seuil) / 2) & (reparti[i] > (1 - seuil) / 2):
        a = i
    if (reparti[i - 1] < (1 + seuil) / 2) & (reparti[i] >= (1 + seuil) / 2):
        b = i

"Je calcule et j'affiche p(a <= X <= b)"
pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
print("l'IF au seuil de", seuil, "de la va X est :",
      "[", a, ";", b, "],\n sa probabilité est", pIF)


"---------------------------------------------------------------------"
"----------------------- GRAPHIQUES ----------------------------------"
"Différencier par la couleur les valeurs de l'IF"
"Colorer en vert les barres illustrant l'IF dans les graphiques"
"Tracer les droites des seuils de probabilité de l'IF"
"Création de la liste des couleurs des barres"
from matplotlib import pyplot as plt

"Il y a a barres de couleur rouge puis (b - a + 1) barres de couleur verte puis"
"    à nouveau (n - b) bares de couleur rouge"
listCoul = ['red'] * a + ['green'] * (b - a + 1) + ['red'] * (n - b)

"DISTRIBUTION DE PROBABILITÉ"
plt.figure()
plt.bar(x, distrib, color = listCoul)
plt.title("DISTRIBUTION DE PROBABILITÉ")
plt.xlabel("VALEURS DE LA V.A. X")
plt.ylabel("PROBABILITÉ")
plt.grid()
plt.show()

"RÉPARTITION DE PROBABILITÉ (PROBABILITÉS CUMULÉES CROISSANTES)"
plt.figure()
plt.bar(x, reparti, color = listCoul)
plt.plot((0, n), ((1 - seuil) / 2, (1 - seuil) / 2), color = 'red')
plt.plot((0, n), ((1 + seuil) / 2, (1 + seuil) / 2), color = 'red')
plt.title("RÉPARTITION DE PROBABILITÉ")
plt.xlabel("VALEURS DE LA V.A. X")
plt.ylabel("PROBABILITÉS CUMULÉES CROISSANTES")
plt.grid()
plt.show()


"---------------------------------------------------"
"---------------------------------------------------"
"Une fonction correspondant à ALGO 2"
" Nécessite pyplot de matplotlib et binom de scipy.stats"
def IFBino2(n = 10, p = .5, seuil = .95):
    from scipy.stats import binom
    from matplotlib import pyplot as plt
    x = range(n + 1)
    reparti = binom.cdf(x, n, p)
    a = sum(reparti <= (1 - seuil) / 2)
    b = sum(reparti < (1 + seuil) / 2)
    pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
    print("l'IF au seuil de", seuil, "de la va X est :",
          "[", a, ";", b, "],\n sa probabilité est", pIF)
    listCoul = ['red'] * a + ['green'] * (b - a + 1) + ['red'] * (n - b)
    plt.figure()
    plt.bar(x, reparti, color = listCoul)
    plt.plot((0, n), ((1 - seuil) / 2, (1 - seuil) / 2), color = "red")
    plt.plot((0, n), ((1 + seuil) / 2, (1 + seuil) / 2), color = "red")
    plt.title("RÉPARTITION DE PROBABILITÉ")
    plt.xlabel("VALEURS DE LA V.A. X")
    plt.ylabel("PROBABILITÉS CUMULÉES CROISSANTES")
    plt.grid()
    plt.show()


"---------------------------------------------------"
"Une fonction correspondant à ALGO 3"
" Nécessite pyplot de matplotlib et binom de scipy.stats"
def IFBino3(n = 10, p = .5, seuil = .95):
    from scipy.stats import binom
    from matplotlib import pyplot as plt
    x = range(n + 1)
    reparti = binom.cdf(x, n, p)
    i = 0
    while reparti[i] <= (1 - seuil) / 2:
        i += 1
    a = i
    j = 0
    while reparti[j] < (1 + seuil) / 2:
        j += 1
    b = j
    pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
    print("l'IF au seuil de", seuil, "de la va X est :",
          "[", a, ";", b, "],\n sa probabilité est", pIF)
    listCoul = ['red'] * a + ['green'] * (b - a + 1) + ['red'] * (n - b)
    plt.figure()
    plt.bar(x, reparti, color = listCoul)
    plt.plot((0, n), ((1 - seuil) / 2, (1 - seuil) / 2), color = 'red')
    plt.plot((0, n), ((1 + seuil) / 2, (1 + seuil) / 2), color = 'red')
    plt.title("RÉPARTITION DE PROBABILITÉ")
    plt.xlabel("VALEURS DE LA V.A. X")
    plt.ylabel("PROBABILITÉS CUMULÉES CROISSANTES")
    plt.grid()
    plt.show()


"---------------------------------------------------"
"Une fonction correspondant à ALGO 4"
" Nécessite pyplot de matplotlib et binom de scipy.stats"
def IFBino4(n = 10, p = .5, seuil = .95):
    from scipy.stats import binom
    from matplotlib import pyplot as plt
    x = range(n + 1)
    reparti = binom.cdf(x, n, p)
    i = 0
    while reparti[i] <= (1 - seuil) / 2:
        i += 1
    a = i
    while reparti[i] < (1 + seuil) / 2:
        i += 1
    b = i
    pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
    print("l'IF au seuil de", seuil, "de la va X est :",
          "[", a, ";", b, "],\n sa probabilité est", pIF)
    listCoul = ['red'] * a + ['green'] * (b - a + 1) + ['red'] * (n - b)
    plt.figure()
    plt.bar(x, reparti, color = listCoul)
    plt.plot((0, n), ((1 - seuil) / 2, (1 - seuil) / 2), color = 'red')
    plt.plot((0, n), ((1 + seuil) / 2, (1 + seuil) / 2), color = 'red')
    plt.title("RÉPARTITION DE PROBABILITÉ")
    plt.xlabel("VALEURS DE LA V.A. X")
    plt.ylabel("PROBABILITÉS CUMULÉES CROISSANTES")
    plt.grid()
    plt.show()


"---------------------------------------------------"
"Une fonction correspondant à ALGO 5"
" Nécessite pyplot de matplotlib et binom de scipy.stats"
def IFBino5(n = 10, p = .5, seuil = .95):
    from scipy.stats import binom
    from matplotlib import pyplot as plt
    x = range(n + 1)
    reparti = binom.cdf(x, n, p)
    if reparti[0] > (1 - seuil) / 2:
        a = 0
    for i in range(2, n + 1):
        if (reparti[i - 1] <= (1 - seuil) / 2) & (reparti[i] > (1 - seuil) / 2):
            a = i
        if (reparti[i - 1] < (1 + seuil) / 2) & (reparti[i] >= (1 + seuil) / 2):
            b = i
    pIF = binom.cdf(b, n, p) - binom.cdf(a - 1, n, p)
    print("l'IF au seuil de", seuil, "de la va X est :",
          "[", a, ";", b, "],\n sa probabilité est", pIF)
    listCoul = ['red'] * a + ['green'] * (b - a + 1) + ['red'] * (n - b)
    plt.figure()
    plt.bar(x, reparti, color = listCoul)
    plt.plot((0, n), ((1 - seuil) / 2, (1 - seuil) / 2), color = 'red')
    plt.plot((0, n), ((1 + seuil) / 2, (1 + seuil) / 2), color = 'red')
    plt.title("RÉPARTITION DE PROBABILITÉ")
    plt.xlabel("VALEURS DE LA V.A. X")
    plt.ylabel("PROBABILITÉS CUMULÉES CROISSANTES")
    plt.grid()
    plt.show()



