#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue May 22 18:14:18 2018
@author: boiboite
On peut calculer un temps d'exécution avec %timeit(fonction)
"""

"------------------ ANTILLES GUYANE Septembre 2013 ---------------------"
" L'algorithme de l'énoncé, exercice 4-1 :"
"    Simule une marche et affiche la dernière position de TOM"
"    Utilise sample de random"

def robtom1():
    from random import sample
    x, y = 0, 0
    urne = {-1, 0, 1}
    while y <= 1 and y >= -1 and x <= 9:
        n = sample(urne, 1)
        y = y + n[0]
        x = x + 1
    # print("Dernière position de TOM, x =", x, "y =", y)
    return(x, y)

" L'algorithme de l'énoncé, exercice 4-2 : "
"    Simule une marche et affiche 'TOM a passé le pont' ou"
"    TOM est tombé à l'eau'... Utilise robtom1 ... Il y a une erreur ..."
def robtom2():
    posiT = robtom1()
    if posiT[0] < 10:
        message = "TOM est tombé à l'eau en " + str(posiT)
    else:
        message = "TOM a passé le pont en " + str(posiT)
    return(message)

"----------------------- PROLONGEMENT 1 -----------------------------"
"Illustration graphique de la simulation d'une 'marche' = "
"   d'un cheminement du robot TOM et affichage du résultat"
"  La représentation graphique de l'arrivée doit être améliorée"
def robtom3():
    from random import sample
    from matplotlib import pyplot as plt
    urne = {-1, 0, 1}
    x, y, sortie = 0, 0, 0
    posisTomX = [0] ; posisTomY = [0]
    while y <= 1 and y >= -1 and x <= 9:
        n = sample(urne, 1)
        y = y + n[0]
        x = x + 1
        posiT = (x, y)
        posisTomX.append(x)
        posisTomY.append(y)
    if y == -2 or y == 2:
        message = "TOM est tombé \nà l'eau en " + str(posiT)
    else:
        message = "TOM a passé \nle pont en " + str(posiT)
        sortie = 1
    plt.figure()
    plt.plot((0, 10), (-2, 2), ls = 'none')
    plt.xticks(range(11)) ; plt.yticks(range(-2, 3))
    plt.fill((0, 10, 10, 0), (-1, -1, 1, 1), alpha = 0.2,
             color = 'green')
    plt.plot(posisTomX, posisTomY, 'bo-')
    if sortie == 1:
        plt.text(x, y, message, va = 'bottom', ha = 'center',
             color = 'red')
    else:
        plt.plot(x, y, marker = '*',
                 markerfacecolor = 'red', markersize = 10)
        plt.text(x, y, message, va = 'bottom', ha = 'center',
             color = 'blue')
    plt.grid()
    plt.show()

"----------------------- PROLONGEMENT 1 BIS -----------------------------"
"Illustration graphique d'une simulation"
"   d'un cheminement du robot TOM et affichage du résultat"
"  La représentation graphique de l'arrivée est améliorée"
def robtom3_1():
    from random import sample
    from matplotlib import pyplot as plt
    urne = {-1, 0, 1}
    x, y, sortie = 0, 0, 0
    posisTomX = [0] ; posisTomY = [0]
    while y <= 1 and y >= -1 and x <= 9:
        n = sample(urne, 1)
        y = y + n[0]
        x = x + 1
        posisTomX.append(x)
        posisTomY.append(y)
    if y == -2 or y == 2:
        message = "TOM est tombé \nà l'eau"
    else:
        message = "TOM a passé \nle pont"
        sortie = 1
    plt.figure()
    plt.plot((0, 10), (-2, 2), ls = 'none')
    plt.xticks(range(11)) ; plt.yticks(range(-2, 3))
    plt.fill((0, 10, 10, 0), (-1, -1, 1, 1), alpha = 0.3, color = 'green')
    if sortie == 1:
        plt.plot(posisTomX, posisTomY, 'go-')
        plt.text(x, y, message, va = 'bottom', ha = 'center',
             color = 'green')
    else:
        plt.plot(posisTomX[0:x], posisTomY[0:x], 'bo-')
        if y < 0:        
            plt.plot(x - 0.8, y + 0.8, marker = '*',
                     markerfacecolor = 'red', markersize = 10)
            plt.text(x - 0.8, y + 0.8, message, va = 'top', ha = 'center',
                     color = 'blue')
        else:
            plt.plot(x - 0.8, y - 0.8, marker = '*',
                     markerfacecolor = 'red', markersize = 10)
            plt.text(x - 0.8, y - 0.8, message, va = 'bottom', ha = 'center',
                     color = 'blue')
    plt.grid()
    plt.show()

"----------------------- PROLONGEMENT 2 ---------------------------------"
"Il s'agit maintenant d'estimer, par simulation, la probabilité"
"    de passer le pont ... Il suffit de passer le pont ... "
"    robtom4_1 utilise robtom4_0"
"-----------------------"
" Simule une marche et retourne son résultat"
def robtom4_0():
    from random import sample
    x, y = 0, 0
    urne = {-1, 0, 1}
    while y <= 1 and y >= -1 and x <= 9:
        n = sample(urne, 1)
        y = y + n[0]
        x = x + 1
    if y == -2 or y == 2:
        passage = 0
    else:
        passage = 1
    return(passage)

"-----------------------"
" Simule nbsim marches et retourne la fréquence de passage"
"    N'utilise pas les listes, utilise robtom4_0"
def robtom4_1(nbsim = 5000):
    nbPassages = 0
    for i in range(nbsim):
        nbPassages = nbPassages + robtom4_0()
    freqPassage = nbPassages / nbsim
    print("Une estimation de la probabilité de passage est :", freqPassage)
    
"-----------------------"
" Simule nbsim marches et retourne la fréquence des résultats de la marche"
"    Utilise les listes sans opérateur particulier, utilise robtom4_0"
def robtom4_2(nbsim = 5000):
    tableauEffec = [0] * 2
    for i in range(nbsim):
        passage = robtom4_0()
        # tableauEffec[robtom4_0()] = tableauEffec[robtom4_0()] + 1
        tableauEffec[passage] = tableauEffec[passage] + 1
    freqMarche = [tableauEffec[i] / nbsim for i in range(2)]
    print("Tableau des fréquences des résultats de la marche :", freqMarche)

"-----------------------"
" Simule nbsim marches et retourne la fréquence des résultats de la marche"
"    Utilise les listes ET les opérateurs particuliers, utilise robtom4_0"
def robtom4_3(nbsim = 5000):
    from collections import Counter
    seriepassages = [robtom4_0() for i in range(nbsim)]
    tableauEffec = Counter(seriepassages)
    freqMarche = [tableauEffec[i] / nbsim for i in range(2)]
    print("Tableau des fréquences des résultats de la marche :", freqMarche)

" On peut calculer un temps d'exécution avec %timeit(fonction)"

"----------------------- PROLONGEMENT 3 ---------------------------------"
"Il s'agit de calculer une estimation des probabilités d'arrivée"
"    sur chacun des 3 points d'arrivée du passage du pont"
"-----------------------"
" Simule une marche et retourne l'ordonnée du point de fin de la marche"
"     utilise sample de random"
def robtom5_0():
    from random import sample
    x, y = 0, 0
    urne = {-1, 0, 1}
    while y <= 1 and y >= -1 and x <= 9:
        n = sample(urne, 1)
        y = y + n[0]
        x = x + 1
    return(y)

"-----------------------"
" Simule nbsim marches et retourne la fréquence des 3 points de passage du pont"
"    utilise robtom5_0()"
def robtom5_1(nbsim = 5000):
    tabloEffecPassage = [0] * 3
    for i in range(nbsim):
        y = robtom5_0()
        if y == -1:
            tabloEffecPassage[0] += 1
        if y == 0:
            tabloEffecPassage[1] += 1
        if y == 1:
            tabloEffecPassage[2] += 1
    tabloFreqPassage = [tabloEffecPassage[i] / nbsim for i in range(3)]
    return(tabloFreqPassage)

"-----------------------"
" Réalise le graphique en disque illustrant la fréquence"
"    de chacun des trois points de passage du pont"
"    utilise robtom5_0(), robtom5_1() et numpy"
def robtom5_2(nbsim = 5000):
    from matplotlib import pyplot as plt
    from numpy import pi
    from random import random
    tabloFreqPassage = robtom5_1(nbsim)
    distribRayon = [tabloFreqPassage[i] / max(tabloFreqPassage) * 40 for i in range(3)]
    MessageFreqPassage = ('Une estimation de la probabilité\nde passage du pont est de '
        + str(round(sum(tabloFreqPassage), 4)))
    airedisques = [pi * distribRayon[i]**2 for i in range(3)]
    couleurs = [random() for i in range(3)]
    plt.figure()
    plt.fill((0, 1, 1, 0), (-1, -1, 1, 1), alpha = 0.3, color = 'green')
    plt.scatter((1, 1, 1), (-1, 0, 1),
                s = airedisques, c = couleurs, alpha = .6)
    plt.xticks(range(3), ('', '', ''))
    plt.yticks(range(-2, 3), ('', -1, 0, 1, ''))
    for i in range(3):
        plt.text(1, i - 1, tabloFreqPassage[i])
    plt.text(0, -2, MessageFreqPassage, horizontalalignment = 'left',
             verticalalignment = 'bottom')
    plt.title('Distribution des fréquences simulées\ndes points de passage du pont')
    plt.ylabel('Ordonnées des points de passage')
    plt.grid()
    plt.show()
